package example.isearch;

import java.util.Random;
import java.lang.Math;

/**
 * Simple distributions not provided by java
 */
public class ExtendedRandom extends Random {
    public ExtendedRandom(long seed) {
        super(seed);
    }

    public int nextPoisson(double mean) {
        double emean = Math.exp(-1 * mean);
        double product = 1;
        int count = 0;
        int result = 0;
        while (product >= emean) {
            product *= nextDouble();
            result = count;
            count++; // keep result one behind
        }
        return result;
    }

    public double nextExponential(double b) {
        return -1 * b * Math.log(nextDouble());
    }

    public double nextPower(double base, double a) {
        return base / Math.pow(nextDouble(), a) - base;
    }
}
